#include <fstream>
#include <iostream>
using namespace std;

void print (fstream &fin)
{
    double d;
    fin.clear ();
    fin.seekg (0);
    fin.read ((char*)&d, sizeof(double));
    while (fin)
    {
        cout << d << endl;
        fin.read ((char*)&d, sizeof(double));
    };
    cout << endl;
};

int main ()
{
    fstream fin ("bin_out4.dbl", ios::in | ios::out);
    double d, min, max;
    int pos=0, minpos=0, maxpos=0;
    fin.read ((char*)&d, sizeof(double));
    min = max = d;
    while (fin)
    {
        if (d < min)
        {
            min = d;
            minpos = pos;
        }
        else if (d > max)
        {
            max = d;
            maxpos = pos;
        };
        fin.read ((char*)&d, sizeof(double));
        pos++;
    };
    print (fin);
    if (minpos != maxpos)
    {
        fin.clear ();
        fin.seekg (minpos*sizeof(double));
        fin.write ((char*)&max, sizeof(double));
        fin.seekp (maxpos*sizeof(double));
        fin.write ((char*)&min, sizeof(double));
    };
    print (fin);
    fin.close ();
    return 0;
}
