#include <fstream>
#include <iostream>
using namespace std;
const int buffer_size = 20;

class person
{
    char name[buffer_size];
    int age;
public:    
    bool read1 (istream &fin)
    {
        fin.read (name, buffer_size);
        fin.read ((char*)&age, sizeof(age));
        return fin.good ();
    };
    bool read2 (istream &fin)
    {
        int slen;
        fin.read ((char*)&slen, 1);
        fin.read (name, slen);
        name[slen] = '\0';
        fin.read ((char*)&age, 1);
        return fin.good ();
    };
    void print ()
    {
        cout << name << " " << age << endl;
    }
};

int main ()
{
    person p;
    ifstream fin1 ("bin_out7a.prs");
    while (p.read1 (fin1)) p.print ();
    fin1.close ();
    ifstream fin2 ("bin_out7b.prs");
    while (p.read2 (fin2)) p.print ();
    fin2.close ();
    return 0;
}
